<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: modules/mtlg-modul-menu/mtlg-menu-modul.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: modules/mtlg-modul-menu/mtlg-menu-modul.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * @Author: Thiemo Leonhardt &lt;thiemo>
 * @Date:   2017-07-27T13:10:43+02:00
 * @Email:  leonhardt@cs.rwth-aachen.de
 * @Last modified by:   thiemo
 * @Last modified time: 2017-10-01T20:08:21+02:00
 */



"use strict";

/**
 * @namespace menu
 * @memberof MTLG
 *
**/
window.MTLG = (function(m) {

  var menu = (function() {
    // options
    var edgesToClick; // how many edges to click to open the menu
    var _clickedEdges; // var to count how many edges are clicked
    var rotateAngle; // var to rotate the elements in the circle
    var timerCount; // timer till the game buttons reset

    var menuContainer;
    var menuContent;
    var _gameMenuButtons = []; // array of the game buttons to open the menu
    var _menuOpen;
    var edges;
    var _zoll;
    var _gameButtonTimer; // Timer for gameMenuButtons

    // Private functions

    function _createOverlay() {
      var o = document.getElementById('tangible_overlay');

      menuContainer = document.createElement("div");
      menuContent = document.createElement("div");

      menuContainer.setAttribute('id', 'overlayMenu');
      o.parentNode.insertBefore(menuContainer, o.nextSibling);

      menuContent.setAttribute('id', 'menuContent');
      menuContainer.appendChild(menuContent);
    }

    function _addMenuEntryPic(path, callback) {
      var entry = document.createElement("img");
      entry.setAttribute('class', 'menuEntryImg');
      entry.src = path;
      entry.addEventListener('click', callback);
      menuContent.appendChild(entry);
    }

    /**
     * _addMenuEntryText - Adds a menu entry as text. It is possible to choose wheter it is displayed as one to four words. Default words are 4.
     *
     * @param {type} text     The text of the menu entry.
     * @param {type} callback The callback function of the menu entry.
     * @param {type} edges    It is possible to choose between 1 to 4 words for a menu entry.
     *
     * @return {type} Description
     */
    function _addMenuEntryText(text, callback, edges) {
      var entry = document.createElement("div");
      var textArray = [];
      var edgeArray = ['textTop', 'textDown', 'textLeft', 'textRight'];
      var edgeConstMiddle = [-0.35, -0.80, -0.70, -1.70];
      var edgeConstSmall = [-0.25, -0.95, -0.80, -1.80];
      var i;
      var textBounding;

      edges = edges || 4;

      entry.setAttribute('class', 'menuEntryText');


      for (i = 0; i &lt; edges; i++) {
        textArray.push(document.createElement("div"));
        textArray[i].innerHTML = text;
        if (edges > 1) {
          textArray[i].setAttribute('id', edgeArray[i]);
        }
        textArray[i].addEventListener('touchstart', callback);
        entry.appendChild(textArray[i]);
      }

      menuContent.appendChild(entry);

      if (edges > 1) {
        textBounding = textArray[0].getBoundingClientRect().width;

        if (textBounding &lt; 70) {
          for (i = 0; i &lt; edges; i++) {
            _styleEdge(textArray[i], textBounding * edgeConstSmall[i], i);
          }
        } else {
          for (i = 0; i &lt; edges; i++) {
            _styleEdge(textArray[i], textBounding * edgeConstMiddle[i], i);
          }
        }
      }

      function _styleEdge(obj, constStyle, edge) {
        switch (edge) {
          case 0:
            obj.style.top = constStyle + "px";
            break;
          case 1:
            obj.style.bottom = constStyle + "px";
            break;
          case 2:
            obj.style.left = constStyle + "px";
            break;
          case 3:
            obj.style.right = constStyle + "px";
            break;
          default:
            console.log("function _styleEdge no or false input");
        }
      }
    }

    function _addMenuGameButtons() {
      var o = document.getElementById('overlayMenu');
      var i;

      for (i = 0; i &lt; edges; i++) {
        _gameMenuButtons.push(document.createElement("div"));
        _gameMenuButtons[i].setAttribute('class', 'gameMenuButtons');
        _gameMenuButtons[i].addEventListener('click', _handleGameMenu);
        o.parentNode.insertBefore(_gameMenuButtons[i], o.nextSibling);
      }

      _setPositionGameButtons(edges);
      //_resetMenuGameButtons();
    }

    function _setPositionGameButtons(edg) {
      var posEdges = ["ol", "or", "ul", "ur"];
      var i;

      for (i = 0; i &lt; edg; i++) {
        _gameMenuButtons[i].className += " " + posEdges[i];
      }
    }

    function _resetMenuGameButtons(obj) {
      var i;
      _clickedEdges = 0;

      if (!_menuOpen) {
        if (obj) {
          obj.style.width = "100px";
          obj.style.height = "100px";
        } else {
          for (i = 0; i &lt; edges; i++) {
            _gameMenuButtons[i].style.width = "100px";
            _gameMenuButtons[i].style.height = "100px";
          }
        }
      }
    }

    function _toggleMenuEntries(sw) {
      var entries = menuContainer.children;
      var i;
      var modus;

      sw ? modus = "hidden" : modus = "visible";

      for (i = 0; i &lt; entries.length; i = i + 1) {
        entries[i].style.visibility = modus;
      }
    }

    //
    function _groupMenuEntries() {
      var screenH = window.innerHeight;
      var screenW = window.innerWidth;
      var p, i;

      var btn = menuContent.children;

      for (i = 0; i &lt; btn.length; i = i + 1) {
        p = _circle(i + 1, 15, btn.length, rotateAngle);
        btn[i].style.top = p.x + "%";
        btn[i].style.left = p.y + "%";
        btn[i].style.transform = "rotate(" + p.rotation + "deg)";
        //console.log(p.x + " " + p.y);
      }
    }

    /**
     * _circle - calculate a position on a given circle
     *
     * @param {type} pos           The position of the element 0...n.
     * @param {type} radius        The radius of the circle.
     * @param {type} nbrOfelements This factor is the number of elements to place on the circle.
     * @param {type} rotFak        This factor rotate the position in the circle in PI / rotFak.
     *
     * @return {type} Returns a Point with x, y and the rotation depending on the position and the middle of the circle.
     */
    function _circle(pos, radius, nbrOfelements, rotFak) {
      var alpha = pos * Math.PI * 2 / nbrOfelements;
      var _p = new p();
      var fak;

      rotFak ? fak = Math.PI / rotFak : fak = 0;

      function p() {
        this.x = 0;
        this.y = 0;
        this.rotation = 0;
      }

      _p.x = Math.cos(alpha + fak) * radius + 50;
      _p.y = Math.sin(alpha + fak) * radius + 50;
      _p.rotation = (alpha + fak) * -180 / Math.PI;

      return _p;
    }

    // Timer function
    // https://stackoverflow.com/questions/3969475/javascript-pause-settimeout
    function Timer(callback, delay) {
      var timerId, start, remaining = delay;

      this.pause = function() {
        window.clearTimeout(timerId);
        remaining -= new Date() - start;
      };

      this.resume = function() {
        start = new Date();
        window.clearTimeout(timerId);
        timerId = window.setTimeout(callback, remaining);
      };

      this.resume();
    }

    // handler

    function _handleMenuEntries() {

    }

    function _handleGameMenu() {
      _clickedEdges += 1;
      _gameButtonTimer.resume();

      if (_clickedEdges === edgesToClick) {
        _gameButtonTimer.pause();
        openMenu();
      }

      this.style.width = "0%";
      this.style.height = "0%";
    }

    function _hideGameMenu() {
      _gameMenuButtons.forEach(function(obj) {
        obj.style.width = "0%";
        obj.style.height = "0%";
      });
    }

    function _addBasicMenuEntries(){
      //_addMenuEntryText("Sound", function() {}, 1); // exit to main menu
      //_addMenuEntryText("Display", function() {}, 1); // exit to main menu


      //https://www.iconfinder.com/icons/1041633/close_icon#size=512
      _addMenuEntryPic("assets/img/module/menu/exit.svg", function() {
        console.log("Return to start screen. Maybe to games overview.");
        console.log("should call lc.mainMenu"); // TODO
      });
      //_addMenuEntryText("Exit", function() {}, 1); // exit to main menu

      // https://www.iconfinder.com/icons/106227/close_icon#size=512
      _addMenuEntryPic("assets/img/module/menu/close.svg", closeMenu);
      //_addMenuEntryText("Close", closeMenu, 1);

      _addMenuGameButtons();
    }


    // ==============================================  Public functions

    /**
     * @function openMenu - Description
     * @memberof! MTLG.menu
     *
     * @return {type} Description
     */
    function openMenu() {
      _menuOpen = true;
      _toggleMenuEntries(false);
      menuContainer.style.width = "100%";
      menuContainer.style.height = "100%";
      menuContainer.style.top = "0%";
      menuContainer.style.left = "0%";
      _groupMenuEntries();
    }

    /**
     * @function closeMenu - Description
     * @memberof! MTLG.menu
     *
     * @return {type} Description
     */
    function closeMenu() {
      _menuOpen = false;
      _toggleMenuEntries(true);
      menuContainer.style.width = "0%";
      menuContainer.style.height = "0%";
      menuContainer.style.top = "50%";
      menuContainer.style.left = "50%";
      _resetMenuGameButtons();
    }

    /**
     * @function startMenu - shows the menu buttons on the edges
     * @memberof! MTLG.menu
     *
     */
    function startMenu() {
      // starts the Menu
      _resetMenuGameButtons();
    }


    /**
     *
     * @function subMenu - Description
     * @memberof! MTLG.menu
     *
     */
    function subMenu(callback){
      //https://www.iconfinder.com/icons/1041637/set_setting_icon#size=512
      _addMenuEntryPic("assets/img/module/menu/settings.svg", function() {
        closeMenu();
        callback();
      });
      //_addMenuEntryText("Settings", function() {}, 1); // exit to main menu
    }

    /**
     * @function stopMenu - hides the menu buttons on the edges
     * @memberof! MTLG.menu
     *
     */
    function stopMenu() {
      //stops the menu
      closeMenu();
      _hideGameMenu();
    }

    /**
     * @function addEntryText - Add a text menu entry and a callback function as handler
     * @memberof! MTLG.menu
     *
     * @param {type} text     Titel
     * @param {type} callback Description
     *
     * @return {type} Description
     */
    function addMenuEntryText(text, callback) {
      _addMenuEntryText(text, callback);
    }


    /**
     * @function addEntryImg - Add a image menu entry and a callback function as handler
     * @memberof! MTLG.menu
     *
     * @param {type} text     Titel
     * @param {type} callback Description
     *
     * @return {type} Description
     */
    function addMenuEntryImg(path, callback) {
      _addMenuEntryPic(path, callback);
    }


    /**
     * @function setTimer - Description
     * @memberof! MTLG.menu
     *
     * @param {type} timer Description
     *
     * @return {type} Description
     */
    function setTimer(timer) {
        timerCount = timer;
    }


    /**
     * @function setEdgesToClick - Description
     * @memberof! MTLG.menu
     *
     * @param {type} edges Description
     *
     * @return {type} Description
     */
    function setEdgesToClick(edges) {
        edgesToClick = edges;
    }


    /**
     * @function setRotateAngel - Description
     * @memberof! MTLG.menu
     *
     * @param {type} ang Description
     */
    function setRotateAngel(ang) {
        rotateAngle = ang;
    }

    /**
     * @function init - initilize the menu modul in MTLG
     * @memberof! MTLG.menu
     *
     * @param {type} options Basic game options to initalize the menu modul.
     */
    function init(options) {
      // fill with inital settings
      console.log("Menu modul loaded.");

      _zoll = options.zoll;
      edges = options.edges || 4;
      edgesToClick = options.edgesToClick || 4;
      rotateAngle = options.rotateAngle || 1;
      timerCount = options.timer || 4000;


      _gameButtonTimer = new Timer(_resetMenuGameButtons, timerCount);
      _gameButtonTimer.pause();

      _createOverlay();
      _addBasicMenuEntries();
    }

    m.addModule(init);

    return {
      init: init,
      open: openMenu,
      close: closeMenu,
      start: startMenu,
      stop: stopMenu,
      // Do not give a developer the choice to add own entries
      //addEntryText: addMenuEntryText,
      //addEntryImg: addMenuEntryImg,
      addSubMenu: subMenu
    }

  })();

  m.menu = menu;
  return m;
})(window.MTLG||{});
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="MTLG.utilities.graph.html">graph</a></li></ul><h3>Namespaces</h3><ul><li><a href="MTLG.html">MTLG</a></li><li><a href="MTLG.menu.html">menu</a></li><li><a href="MTLG.tangible.html">tangible</a></li><li><a href="MTLG.utilities.html">utilities</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Dec 04 2017 15:08:57 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
